/************************************************************************/
/* sequence.c: This file contains utilities of search result buffer 	*/
/*                                                                      */
/* Modification Log:                                                    */
/*                                                                      */
/* 91/05/21     Sze-Ying Wuu: Modifications made for xdi, Rel 1.0       */
/* 91/02/22     /f/osi/others/quipu/uips/pod/RCS/sequence.c,v 7.1       */
/*              Isode Interim (6.8)                                     */
/************************************************************************/

/* $Header: sequence.c,v 1.8 92/09/01 16:35:14 sywuu Exp $ */

/*
 *    Original source: ISODE Interim Release 6.8
 *    Changes/additions by: Sze-Ying Wuu, Bellcore, <sywuu@thumper.bellcore.com>
 *
 *               Changes and Additions Copyright (c) 1991 Bellcore
 *                            All Rights Reserved
 *
 *    Permission is granted to copy, modify and redistribute this program
 *    in source or binary form provided that it is not sold for
 *    profit, and all copyright notices, permission and nonwarranty notices 
 *    remain intact.
 *
 *    Bellcore makes no warranty and accepts no liability for this program.
 * 
 *
 *                             ISODE NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#include <malloc.h>
#include <string.h>

#include "sequence.h"

/* add entry to sequence buffer */
void add_seq (seq, str)
str_seq *seq;
char *str;
{
  str_seq curr;

  if (*seq) {
    for (curr = *seq; curr->next; curr = curr->next) {}
    curr->next = (struct str_seq *) malloc (sizeof (struct str_seq));
    curr = curr->next;
    curr->strlen = strlen (str);
    curr->dname = malloc ((curr->strlen)+5);
    (void) strcpy(curr->dname, str);
    curr->next = 0;
  } else {
    curr = (struct str_seq *) malloc (sizeof (struct str_seq));
    curr->strlen = strlen (str);
    curr->dname = malloc ((curr->strlen)+5);
    (void) strcpy(curr->dname, str);
    curr->next = 0;
    *seq = curr;
  }
}
	          
/* get the next entry from buffer */
char *get_from_seq (seq_num, seq_ptr)
int seq_num;
str_seq seq_ptr;
{
  for (; seq_num > 1 && seq_ptr; seq_ptr = seq_ptr->next, seq_num--) {}
  if (seq_ptr) return seq_ptr->dname;
  else return 0;
}

/* free buffer */
void free_seq (seq_ptr)
str_seq seq_ptr;
{
  str_seq next_seq;
  
  while (seq_ptr) {
    free((char *) (seq_ptr->dname));
    next_seq = seq_ptr->next;
    free((char *) seq_ptr);
    seq_ptr = next_seq;
  }
}
